; Script generated by the HM NIS Edit Script Wizard.

SetCompressor lzma

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "XBCD"
!define PRODUCT_VERSION "1.07"
!define PRODUCT_PUBLISHER "Redcl0ud"
!define PRODUCT_WEB_SITE "http://phaseone.sytes.net"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"
!define PRODUCT_STARTMENU_REGVAL "NSIS:StartMenuDir"

!define XBCDDevDesc "XBCD XBox Gamepad"
!define RumbleDesc "XBCD Rumble Driver"
!define ConfigDesc "XBCD Setup"
!define KEY_OEM "System\CurrentControlSet\Control\MediaProperties\PrivateProperties\Joystick\OEM\VID_0738&PID_4516"
!define RUMBLE_CLSID "{5A31DDDE-75C8-4678-8DFB-870DE54EDDAD}"
!define CONF_CLSID "{5F9D4D40-3C36-47d2-940C-89161FCCCB94}"
!define ConstantDesc "Constant"
!define SineDesc "Sine"
!define RampDesc "Ramp"
!define SquareDesc "Square"
!define TriangleDesc "Triangle"
!define SawtoothUpDesc "SawtoothUp"
!define SawtoothDownDesc "SawtoothDown"
!define SpringDesc "Spring"
!define FrictionDesc "Friction"
!define DamperDesc "Damper"
!define InertiaDesc "Inertia"
!define CustomDesc "Custom"
!define GUID_ConstantForce "{13541C20-8E33-11D0-9AD0-00A0C9A06E35}"
!define GUID_Sine "{13541C23-8E33-11D0-9AD0-00A0C9A06E35}"
!define GUID_RampForce "{13541C21-8E33-11D0-9AD0-00A0C9A06E35}"
!define GUID_Square "{13541C22-8E33-11D0-9AD0-00A0C9A06E35}"
!define GUID_Triangle "{13541C24-8E33-11D0-9AD0-00A0C9A06E35}"
!define GUID_SawtoothUp "{13541C25-8E33-11D0-9AD0-00A0C9A06E35}"
!define GUID_SawtoothDown "{13541C26-8E33-11D0-9AD0-00A0C9A06E35}"
!define GUID_Spring "{13541C27-8E33-11D0-9AD0-00A0C9A06E35}"
!define GUID_Damper "{13541C28-8E33-11D0-9AD0-00A0C9A06E35}"
!define GUID_Inertia "{13541C29-8E33-11D0-9AD0-00A0C9A06E35}"
!define GUID_Friction "{13541C2A-8E33-11D0-9AD0-00A0C9A06E35}"
!define GUID_Custom "{13541C2B-8E33-11D0-9AD0-00A0C9A06E35}"

; MUI 1.67 compatible ------
!include "MUI.nsh"

; Logic Library
!include "LogicLib.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"

; Welcome page
!insertmacro MUI_PAGE_WELCOME
!insertmacro MUI_PAGE_COMPONENTS
; Directory page
!insertmacro MUI_PAGE_DIRECTORY
; Start menu page
var ICONS_GROUP
!define MUI_STARTMENUPAGE_NODISABLE
!define MUI_STARTMENUPAGE_DEFAULTFOLDER "XBCD"
!define MUI_STARTMENUPAGE_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "${PRODUCT_STARTMENU_REGVAL}"
!insertmacro MUI_PAGE_STARTMENU Application $ICONS_GROUP
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_FINISHPAGE_SHOWREADME "$INSTDIR\Readme.txt"
!define MUI_FINISHPAGE_SHOWREADME_NOTCHECKED
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"

; MUI end ------

; IsWindowsXPOrHigher
;
; Based on Yazno's function, http://yazno.tripod.com/powerpimpit/
; Updated by Joost Verburg
; Updated by Redcl0ud
;
; Returns on top of stack
;
; Windows Version (95, 98, ME, NT x.x, 2000, XP, 2003)
; or
; '' (Unknown Windows Version)
;
; Usage:
;   Call IsWindowsXPOrHigher
;   Pop $R0
;   ; at this point $R0 is "yes" or "no"

Function IsWindowsXPOrHigher
  Push $R0
  Push $R1
  
  ReadRegStr $R0 HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion" "CurrentVersion"

  ${If} $R0 != ''
    Goto lbl_winnt
  ${EndIf}

  ; we are not NT
  ReadRegStr $R0 HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion" "VersionNumber"

  StrCpy $R0 'no'
  Goto lbl_done

  lbl_winnt:

  StrCpy $R1 $R0 1

  StrCmp $R1 '3' lbl_winnt_x
  StrCmp $R1 '4' lbl_winnt_x

  StrCpy $R1 $R0 3

  StrCmp $R1 '5.0' lbl_winnt_2000
  StrCmp $R1 '5.1' lbl_winnt_XP
  StrCmp $R1 '5.2' lbl_winnt_2003 lbl_error

  lbl_winnt_x:
  StrCpy $R0 'no'
  Goto lbl_done

  lbl_winnt_2000:
  Strcpy $R0 'no'
  Goto lbl_done

  lbl_winnt_XP:
  Strcpy $R0 'yes'
  Goto lbl_done

  lbl_winnt_2003:
  Strcpy $R0 'yes'
  Goto lbl_done

  lbl_error:
  Strcpy $R0 'no'

  lbl_done:
  Pop $R1
  Exch $R0
FunctionEnd

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "XBCDv107.exe"
InstallDir "$PROGRAMFILES\XBCD"
;InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show

Function .onInit
  MessageBox MB_YESNO "If this is not an upgrade, you will need to uninstall $\nthe existing XBox controller in Device Manager before continuing. $\nDo you wish to continue?" /SD IDYES IDYES NoAbort
    Abort ; causes installer to quit.
  NoAbort:
  
  StrCpy $ICONS_GROUP 'XBCD'
FunctionEnd


Section "Driver" SEC01
  SectionIn RO
  
  SetOverwrite on
  SetOutPath "$INSTDIR"
  File "Readme.txt"
  File "XBCD.ico"
  SetOutPath "$WINDIR\Inf"
  File "XBCD.inf"
  SetOutPath "$WINDIR\System32\Drivers"
  File "xbcd.sys"
  SetOutPath "$SYSDIR"

  DeleteRegKey HKLM "${KEY_OEM}"
  DeleteRegKey HKLM "System\CurrentControlSet\Control\MediaProperties\PrivateProperties\DirectInput\VID_0738&PID_4516"
  
  CreateDirectory "$SMPROGRAMS\$ICONS_GROUP"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Readme.lnk" "$INSTDIR\Readme.txt"
  
  Call IsWindowsXPOrHigher
  Pop $R0
  ${If} $R0 == 'yes'
    File "XBCDSU.dll"
    WriteRegStr HKCR "CLSID\${CONF_CLSID}" "" "${ConfigDesc}"
    WriteRegStr HKCR "CLSID\${CONF_CLSID}\InProcServer32" "" "$SYSDIR\XBCDSU.dll"
    WriteRegStr HKCR "CLSID\${CONF_CLSID}\InProcServer32" "ThreadingModel" "Apartment"
    WriteRegStr HKLM "${KEY_OEM}" "ConfigCLSID" "${CONF_CLSID}"
    CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Setup Utility.lnk" "$SYSDIR\Rundll32.exe" "XBCDSU.dll, DllGetClassObject" "$INSTDIR\XBCD.ico" 0
  ${Else}
    File "/oname=XBCDSU.cpl" "XBCDSU.dll"
    CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Setup Utility.lnk" "$SYSDIR\XBCDSU.cpl" "" "$INSTDIR\XBCD.ico" 0
  ${EndIf}
  
  File "XBCDIF.dll"

  WriteRegBin HKLM "${KEY_OEM}" "OEMData" "2300881118000000"
  WriteRegStr HKLM "${KEY_OEM}" "OEMName" "${XBCDDevDesc}"

  WriteRegStr HKLM "${KEY_OEM}\Axes\0" "" "X"
  WriteRegBin HKLM "${KEY_OEM}\Axes\0" "Attributes" "0181000001003000"
  WriteRegStr HKLM "${KEY_OEM}\Axes\1" "" "Y"
  WriteRegBin HKLM "${KEY_OEM}\Axes\1" "Attributes" "0181000001003100"
  
  ;WriteRegStr HKLM "${KEY_OEM}\Axes\2" "" "Z"
  ;WriteRegBin HKLM "${KEY_OEM}\Axes\2" "Attributes" "0081000001003200"
  ;WriteRegStr HKLM "${KEY_OEM}\Axes\3" "" "RX"
  ;WriteRegBin HKLM "${KEY_OEM}\Axes\3" "Attributes" "0081000001003300"
  ;WriteRegStr HKLM "${KEY_OEM}\Axes\4" "" "RY"
  ;WriteRegBin HKLM "${KEY_OEM}\Axes\4" "Attributes" "0081000001003400"
  ;WriteRegStr HKLM "${KEY_OEM}\Axes\5" "" "RZ"
  ;WriteRegBin HKLM "${KEY_OEM}\Axes\5" "Attributes" "0081000001003500"
  ;WriteRegStr HKLM "${KEY_OEM}\Axes\6" "" "Slider"
  ;WriteRegBin HKLM "${KEY_OEM}\Axes\6" "Attributes" "0081000001003600"

  WriteRegStr HKLM "${KEY_OEM}\Buttons\0" "" "1"
  WriteRegBin HKLM "${KEY_OEM}\Buttons\0" "Attributes" "0280000009000100"
  WriteRegStr HKLM "${KEY_OEM}\Buttons\1" "" "2"
  WriteRegBin HKLM "${KEY_OEM}\Buttons\1" "Attributes" "0280000009000200"
  WriteRegStr HKLM "${KEY_OEM}\Buttons\2" "" "3"
  WriteRegBin HKLM "${KEY_OEM}\Buttons\2" "Attributes" "0280000009000300"
  WriteRegStr HKLM "${KEY_OEM}\Buttons\3" "" "4"
  WriteRegBin HKLM "${KEY_OEM}\Buttons\3" "Attributes" "0280000009000400"
  WriteRegStr HKLM "${KEY_OEM}\Buttons\4" "" "5"
  WriteRegBin HKLM "${KEY_OEM}\Buttons\4" "Attributes" "0280000009000500"
  WriteRegStr HKLM "${KEY_OEM}\Buttons\5" "" "6"
  WriteRegBin HKLM "${KEY_OEM}\Buttons\5" "Attributes" "0280000009000600"
  WriteRegStr HKLM "${KEY_OEM}\Buttons\6" "" "7"
  WriteRegBin HKLM "${KEY_OEM}\Buttons\6" "Attributes" "0280000009000700"
  WriteRegStr HKLM "${KEY_OEM}\Buttons\7" "" "8"
  WriteRegBin HKLM "${KEY_OEM}\Buttons\7" "Attributes" "0280000009000800"
  WriteRegStr HKLM "${KEY_OEM}\Buttons\8" "" "9"
  WriteRegBin HKLM "${KEY_OEM}\Buttons\8" "Attributes" "0280000009000900"
  WriteRegStr HKLM "${KEY_OEM}\Buttons\9" "" "10"
  WriteRegBin HKLM "${KEY_OEM}\Buttons\9" "Attributes" "0280000009000A00"
  WriteRegStr HKLM "${KEY_OEM}\Buttons\10" "" "11"
  WriteRegBin HKLM "${KEY_OEM}\Buttons\10" "Attributes" "0280000009000B00"
  WriteRegStr HKLM "${KEY_OEM}\Buttons\11" "" "12"
  WriteRegBin HKLM "${KEY_OEM}\Buttons\11" "Attributes" "0280000009000C00"
  WriteRegStr HKLM "${KEY_OEM}\Buttons\12" "" "13"
  WriteRegBin HKLM "${KEY_OEM}\Buttons\12" "Attributes" "0280000009000D00"
  WriteRegStr HKLM "${KEY_OEM}\Buttons\13" "" "14"
  WriteRegBin HKLM "${KEY_OEM}\Buttons\13" "Attributes" "0280000009000E00"
  WriteRegStr HKLM "${KEY_OEM}\Buttons\14" "" "15"
  WriteRegBin HKLM "${KEY_OEM}\Buttons\14" "Attributes" "0280000009000F00"
  WriteRegStr HKLM "${KEY_OEM}\Buttons\15" "" "16"
  WriteRegBin HKLM "${KEY_OEM}\Buttons\15" "Attributes" "0280000009001000"
  WriteRegStr HKLM "${KEY_OEM}\Buttons\16" "" "17"
  WriteRegBin HKLM "${KEY_OEM}\Buttons\16" "Attributes" "0280000009001100"
  WriteRegStr HKLM "${KEY_OEM}\Buttons\17" "" "18"
  WriteRegBin HKLM "${KEY_OEM}\Buttons\17" "Attributes" "0280000009001200"
  WriteRegStr HKLM "${KEY_OEM}\Buttons\18" "" "19"
  WriteRegBin HKLM "${KEY_OEM}\Buttons\18" "Attributes" "0280000009001300"
  WriteRegStr HKLM "${KEY_OEM}\Buttons\19" "" "20"
  WriteRegBin HKLM "${KEY_OEM}\Buttons\19" "Attributes" "0280000009001400"
  WriteRegStr HKLM "${KEY_OEM}\Buttons\20" "" "21"
  WriteRegBin HKLM "${KEY_OEM}\Buttons\20" "Attributes" "0280000009001500"
  WriteRegStr HKLM "${KEY_OEM}\Buttons\21" "" "22"
  WriteRegBin HKLM "${KEY_OEM}\Buttons\21" "Attributes" "0280000009001600"
  WriteRegStr HKLM "${KEY_OEM}\Buttons\22" "" "23"
  WriteRegBin HKLM "${KEY_OEM}\Buttons\22" "Attributes" "0280000009001700"
  WriteRegStr HKLM "${KEY_OEM}\Buttons\23" "" "24"
  WriteRegBin HKLM "${KEY_OEM}\Buttons\23" "Attributes" "0280000009001800"
  
  ;WriteRegStr HKLM "${KEY_OEM}" "OEMXYLabel" "X - Y"
  ;WriteRegStr HKLM "${KEY_OEM}" "OEMZLabel" "Z"
  ;WriteRegStr HKLM "${KEY_OEM}" "OEMRLabel" "RZ"
  ;WriteRegStr HKLM "${KEY_OEM}" "OEMULabel" "Slider"
  ;WriteRegStr HKLM "${KEY_OEM}" "OEMVLabel" "RX"
  ;WriteRegStr HKLM "${KEY_OEM}" "OEMPOVLabel" "POV Hat Switch"
SectionEnd

Section "Rumble Support" SEC02
  SetOverwrite on
  SetOutPath "$SYSDIR"
  File "XBCDR.dll"

  WriteRegStr HKCR "CLSID\${RUMBLE_CLSID}" "" "${RumbleDesc}"
  WriteRegStr HKCR "CLSID\${RUMBLE_CLSID}\InProcServer32" "" "$SYSDIR\XBCDR.dll"
  WriteRegStr HKCR "CLSID\${RUMBLE_CLSID}\InProcServer32" "ThreadingModel" "Both"

  WriteRegBin HKLM "${KEY_OEM}\Axes\0" "FFAttributes" "0A00000000010000"
  WriteRegBin HKLM "${KEY_OEM}\Axes\1" "FFAttributes" "0A00000000010000"

  WriteRegBin HKLM "${KEY_OEM}\OEMForceFeedback" "Attributes" "00000000E8030000E8030000"
  WriteRegStr HKLM "${KEY_OEM}\OEMForceFeedback" "CLSID" "${RUMBLE_CLSID}"

  WriteRegStr HKLM "${KEY_OEM}\OEMForceFeedback\Effects\${GUID_ConstantForce}" "" "${ConstantDesc}"
  WriteRegBin HKLM "${KEY_OEM}\OEMForceFeedback\Effects\${GUID_ConstantForce}" "Attributes" "7301000001060000ED030000ED01000020000000"
  WriteRegStr HKLM "${KEY_OEM}\OEMForceFeedback\Effects\${GUID_Sine}" "" "${SineDesc}"
  WriteRegBin HKLM "${KEY_OEM}\OEMForceFeedback\Effects\${GUID_Sine}" "Attributes" "D302000003060000ED030000ED01000020000000"
  WriteRegStr HKLM "${KEY_OEM}\OEMForceFeedback\Effects\${GUID_RampForce}" "" "${RampDesc}"
  WriteRegBin HKLM "${KEY_OEM}\OEMForceFeedback\Effects\${GUID_RampForce}" "Attributes" "7D00000002060000ED030000ED01000020000000"
  WriteRegStr HKLM "${KEY_OEM}\OEMForceFeedback\Effects\${GUID_Square}" "" "${SquareDesc}"
  WriteRegBin HKLM "${KEY_OEM}\OEMForceFeedback\Effects\${GUID_Square}" "Attributes" "1D01000003060000ED030000ED01000020000000"
  WriteRegStr HKLM "${KEY_OEM}\OEMForceFeedback\Effects\${GUID_Triangle}" "" "${TriangleDesc}"
  WriteRegBin HKLM "${KEY_OEM}\OEMForceFeedback\Effects\${GUID_Triangle}" "Attributes" "CB01000003060000ED030000ED01000020000000"
  WriteRegStr HKLM "${KEY_OEM}\OEMForceFeedback\Effects\${GUID_SawtoothUp}" "" "${SawtoothUpDesc}"
  WriteRegBin HKLM "${KEY_OEM}\OEMForceFeedback\Effects\${GUID_SawtoothUp}" "Attributes" "1E02000003060000ED030000ED01000020000000"
  WriteRegStr HKLM "${KEY_OEM}\OEMForceFeedback\Effects\${GUID_SawtoothDown}" "" "${SawtoothDownDesc}"
  WriteRegBin HKLM "${KEY_OEM}\OEMForceFeedback\Effects\${GUID_SawtoothDown}" "Attributes" "5F03000003060000ED030000ED01000020000000"
  WriteRegStr HKLM "${KEY_OEM}\OEMForceFeedback\Effects\${GUID_Spring}" "" "${SpringDesc}"
  WriteRegBin HKLM "${KEY_OEM}\OEMForceFeedback\Effects\${GUID_Spring}" "Attributes" "9403000004100000650300006501000020000000"
  WriteRegStr HKLM "${KEY_OEM}\OEMForceFeedback\Effects\${GUID_Friction}" "" "${FrictionDesc}"
  WriteRegBin HKLM "${KEY_OEM}\OEMForceFeedback\Effects\${GUID_Friction}" "Attributes" "D700000004100000650300006501000020000000"
  WriteRegStr HKLM "${KEY_OEM}\OEMForceFeedback\Effects\${GUID_Damper}" "" "${DamperDesc}"
  WriteRegBin HKLM "${KEY_OEM}\OEMForceFeedback\Effects\${GUID_Damper}" "Attributes" "7002000004100000650300006501000020000000"
  WriteRegStr HKLM "${KEY_OEM}\OEMForceFeedback\Effects\${GUID_Inertia}" "" "${InertiaDesc}"
  WriteRegBin HKLM "${KEY_OEM}\OEMForceFeedback\Effects\${GUID_Inertia}" "Attributes" "4F02000004100000650300006501000020000000"
  WriteRegStr HKLM "${KEY_OEM}\OEMForceFeedback\Effects\${GUID_Custom}" "" "${CustomDesc}"
  WriteRegBin HKLM "${KEY_OEM}\OEMForceFeedback\Effects\${GUID_Custom}" "Attributes" "3301000005060000ED030000ED01000020000000"
SectionEnd

Section /o "Driver (Debug)" SEC03
  SetOverwrite on
  SetOutPath "$WINDIR\System32\Drivers"
  File ".\Debug\xbcd.sys"
SectionEnd

Section /o "Source Code" SEC04
  SetOverwrite on
  SetOutPath "$INSTDIR\Source Code"
  File /r ".\src\Driver"
  File /r ".\src\Installer"
  File /r ".\src\Rumble"
  File /r ".\src\XBCDSU"
  File /r ".\src\XBCDIF"
  
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Source Code.lnk" "$INSTDIR\Source Code"
SectionEnd

Section -AdditionalIcons
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Website.lnk" "$INSTDIR\${PRODUCT_NAME}.url"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk" "$INSTDIR\uninst.exe"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "${PRODUCT_STARTMENU_REGVAL}" "$ICONS_GROUP"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
  
  MessageBox MB_OK "To finish the installation, please replug the controller or restart the computer." /SD IDOK
SectionEnd

Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) was successfully removed from your computer."
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to completely remove $(^Name) and all of its components?" IDYES +2
  Abort
FunctionEnd

; IsWindowsXPOrHigher
;
; Based on Yazno's function, http://yazno.tripod.com/powerpimpit/
; Updated by Joost Verburg
; Updated by Redcl0ud
;
; Returns on top of stack
;
; Windows Version (95, 98, ME, NT x.x, 2000, XP, 2003)
; or
; '' (Unknown Windows Version)
;
; Usage:
;   Call IsWindowsXPOrHigher
;   Pop $R0
;   ; at this point $R0 is "yes" or "no"

Function un.IsWindowsXPOrHigher
  Push $R0
  Push $R1

  ReadRegStr $R0 HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion" "CurrentVersion"

  ${If} $R0 != ''
    Goto lbl_winnt
  ${EndIf}

  ; we are not NT
  ReadRegStr $R0 HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion" "VersionNumber"

  StrCpy $R0 'no'
  Goto lbl_done

  lbl_winnt:

  StrCpy $R1 $R0 1

  StrCmp $R1 '3' lbl_winnt_x
  StrCmp $R1 '4' lbl_winnt_x

  StrCpy $R1 $R0 3

  StrCmp $R1 '5.0' lbl_winnt_2000
  StrCmp $R1 '5.1' lbl_winnt_XP
  StrCmp $R1 '5.2' lbl_winnt_2003 lbl_error

  lbl_winnt_x:
  StrCpy $R0 'no'
  Goto lbl_done

  lbl_winnt_2000:
  Strcpy $R0 'no'
  Goto lbl_done

  lbl_winnt_XP:
  Strcpy $R0 'yes'
  Goto lbl_done

  lbl_winnt_2003:
  Strcpy $R0 'yes'
  Goto lbl_done

  lbl_error:
  Strcpy $R0 'no'

  lbl_done:
  Pop $R1
  Exch $R0
FunctionEnd

Section Uninstall
  ReadRegStr $ICONS_GROUP ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "${PRODUCT_STARTMENU_REGVAL}"
  Delete "$INSTDIR\${PRODUCT_NAME}.url"
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\Readme.txt"
  Delete "$SYSDIR\XBCDR.dll"
  Delete "$WINDIR\System32\Drivers\xbcd.sys"
  Delete "$WINDIR\Inf\XBCD.inf"
  Delete "$INSTDIR\XBCD.ico"
  
  Call un.IsWindowsXPOrHigher
  Pop $R0
  ${If} $R0 == 'yes'
    Delete "$SYSDIR\XBCDSU.dll"
    DeleteRegKey HKCR "CLSID\${CONF_CLSID}"
    DeleteRegKey HKLM "SYSTEM\CurrentControlSet\Services\XBCD"
  ${Else}
    Delete "$SYSDIR\XBCDSU.cpl"
  ${EndIf}
  
  Delete "$SYSDIR\XBCDIF.dll"
  
  DeleteRegKey HKLM "${KEY_OEM}"
  DeleteRegKey HKLM "System\CurrentControlSet\Control\MediaProperties\PrivateProperties\DirectInput\VID_0738&PID_4516"
  DeleteRegKey HKCR "CLSID\${RUMBLE_CLSID}"

  Delete "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\Website.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\Readme.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\Setup Utility.lnk"

  RMDir "$SMPROGRAMS\$ICONS_GROUP"
  RMDir /r "$INSTDIR\Source Code"
  RMDir "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  ;DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  
  MessageBox MB_OK "To completely remove XBCD, you will need to uninstall $\nthe XBox controller from Device Manager."
  SetAutoClose true
SectionEnd
