unit CAssign;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TfrmCAssign = class(TForm)
    txtControl: TStaticText;
    rdbNone: TRadioButton;
    rdbButton: TRadioButton;
    rdbAxis: TRadioButton;
    rdbPOV: TRadioButton;
    cmdOK: TButton;
    cmdCancel: TButton;
    cmbButton: TComboBox;
    cmbAxis: TComboBox;
    cmbPOV: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure cmdOKClick(Sender: TObject);
    procedure cmdCancelClick(Sender: TObject);
    procedure rdbNoneClick(Sender: TObject);
    procedure rdbButtonClick(Sender: TObject);
    procedure rdbAxisClick(Sender: TObject);
    procedure rdbPOVClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Function AssignControl(sName: String; iOldValue: Integer): Integer;
  end;

var
  frmCAssign: TfrmCAssign;
  iNewValue: Integer;

const

  WinControls2: array[0..42] of String = (
     'None',
     'Button 1', 'Button 2', 'Button 3', 'Button 4', 'Button 5', 'Button 6',
     'Button 7', 'Button 8', 'Button 9', 'Button 10', 'Button 11', 'Button 12',
     'Button 13', 'Button 14', 'Button 15', 'Button 16', 'Button 17', 'Button 18',
     'Button 19', 'Button 20', 'Button 21', 'Button 22', 'Button 23', 'Button 24',
     'X -', 'X +',
     'Y -', 'Y +',
     'Z -', 'Z +',
     'RX -', 'RX +',
     'RY -', 'RY +',
     'RZ -', 'RZ +',
     'Slider -', 'Slider +',
     'POV Up', 'POV Right', 'POV Down', 'POV Left'
  );

  BUTTON_BEGIN = 1;
  BUTTON_END = 24;
  AXIS_BEGIN = 25;
  AXIS_END = 38;
  POV_BEGIN = 39;
  POV_END = 42;

implementation

{$R *.dfm}

procedure TfrmCAssign.FormCreate(Sender: TObject);
var
   iCount: Integer;
begin
     For iCount := BUTTON_BEGIN To BUTTON_END Do Begin
         cmbButton.AddItem(WinControls2[iCount], nil);
     End;

     For iCount := AXIS_BEGIN To AXIS_END Do Begin
         cmbAxis.AddItem(WinControls2[iCount], nil);
     End;

     For iCount := POV_BEGIN To POV_END Do Begin
         cmbPOV.AddItem(WinControls2[iCount], nil);
     End;
end;

Function TfrmCAssign.AssignControl(sName: String; iOldValue: Integer): Integer;
begin
     txtControl.Caption := sName;
     
     iNewValue := iOldValue;

     cmbPOV.ItemIndex := -1;
     cmbPOV.Enabled := False;
     cmbAxis.ItemIndex := -1;
     cmbAxis.Enabled := False;
     cmbButton.ItemIndex := -1;
     cmbButton.Enabled := False;
     
     If (iNewValue < BUTTON_BEGIN) Or (iNewValue > POV_END) Then
     begin
          iNewValue := 0;
     end;

     If iNewValue >= POV_BEGIN Then
     begin
          rdbPOV.Checked := True;

          cmbPOV.ItemIndex := iNewValue - POV_BEGIN;
          cmbPOV.Enabled := True;
     end
     else
     begin
          If iNewValue >= AXIS_BEGIN Then
          begin
               rdbAxis.Checked := True;

               cmbAxis.ItemIndex := iNewValue - AXIS_BEGIN;
               cmbAxis.Enabled := True;
          end
          else
          begin
               If iNewValue >= BUTTON_BEGIN Then
               begin
                    rdbButton.Checked := True;

                    cmbButton.ItemIndex := iNewValue - BUTTON_BEGIN;
                    cmbButton.Enabled := True;
               end
               else
               begin
                    rdbNone.Checked := True;
               end;
          end;
     end;
     frmCAssign.ShowModal;

     Result := iNewValue;
end;

procedure TfrmCAssign.cmdOKClick(Sender: TObject);
begin
     If rdbPOV.Checked Then
     begin
          If cmbPOV.ItemIndex >= 0 Then
          begin
               iNewValue := cmbPOV.ItemIndex + POV_BEGIN;
          end
          else
          begin
               MessageBox(frmCAssign.Handle, 'Please make a valid selection.', 'Warning', MB_OK Or MB_ICONEXCLAMATION);
               Exit;
          end;
     end
     else
     begin
          If rdbAxis.Checked Then
          begin
               If cmbAxis.ItemIndex >= 0 Then
               begin
                    iNewValue := cmbAxis.ItemIndex + AXIS_BEGIN;
               end
               else
               begin
                    MessageBox(frmCAssign.Handle, 'Please make a valid selection.', 'Warning', MB_OK Or MB_ICONEXCLAMATION);
                    Exit;
               end;
          end
          else
          begin
               If rdbButton.Checked Then
               begin
                    If cmbButton.ItemIndex >= 0 Then
                    begin
                         iNewValue := cmbButton.ItemIndex + BUTTON_BEGIN;
                    end
                    else
                    begin
                         MessageBox(frmCAssign.Handle, 'Please make a valid selection.', 'Warning', MB_OK Or MB_ICONEXCLAMATION);
                         Exit;
                    end;
               end
               else
               begin
                    iNewValue := 0;
               end;
          end;
     end;
     
     frmCAssign.Close;
end;

procedure TfrmCAssign.cmdCancelClick(Sender: TObject);
begin
     frmCAssign.Close;
end;

procedure TfrmCAssign.rdbNoneClick(Sender: TObject);
begin
     cmbButton.Enabled := False;
     cmbAxis.Enabled := False;
     cmbPOV.Enabled := False;
end;

procedure TfrmCAssign.rdbButtonClick(Sender: TObject);
begin
     cmbButton.Enabled := True;
     cmbAxis.Enabled := False;
     cmbPOV.Enabled := False;
end;

procedure TfrmCAssign.rdbAxisClick(Sender: TObject);
begin
     cmbButton.Enabled := False;
     cmbAxis.Enabled := True;
     cmbPOV.Enabled := False;
end;

procedure TfrmCAssign.rdbPOVClick(Sender: TObject);
begin
     cmbButton.Enabled := False;
     cmbAxis.Enabled := False;
     cmbPOV.Enabled := True;
end;

end.
